class StackException {
};

class StackUnderflow : public StackException {
};

class StackOverflow : public StackException {
};

class DStack {
public:
  DStack(int depth = 100);	// Constructor

  ~DStack();			// Destructor

  double top() const;		// Just return value at top of stack
  double pop();			// Pop and return top of stack
  void push(double);		// Push value onto stack
  void reset();
private:
  int m_top;
  int m_depth;
  double *m_data;
};

