class Symbol {
  friend class Symtable;
 private:
  Symbol *m_link;
  string m_name;
  double m_value;
    
 public:
  Symbol();
  Symbol(string name, double value);
};

class Symtable {
private:
  static const int N = 101;
  Symbol *m_head[N];

  int hashfun(const char *name) const;

  Symbol *find(string name, int &h) const;

public:

  Symtable();
  
  ~Symtable();

  bool set(string name, double value);
  bool get(string name, double &value) const;
};
